
import rasj.*;
//import niftijio.NiftiVolume;

//import rasj.odmg.*;
import org.odmg.*;

import java.io.IOException;
import java.util.*;


/**
 * DFZ: This is to retrieve the data from Rasdaman
 */
public class RasdamanQuery {

        /*
         * DFZ: unit test
         */
        public static void main(String[] args) throws RasResultIsNoIntervalException, IOException, ODMGException {
                //System.out.println("denoise collection exists? " + isCollExist("denoise"));
                //System.out.println("notpossible collection exists? " + isCollExist("notpossible"));
                query();
        }

        /*
         * DFZ 5/23/16: added
         */
        public static int isCollExist (String coll) throws ODMGException {
                int res = 0; //default is non existent

                String server = "localhost";
                String base = "RASBASE";
                String port = "7001";
                String user = "rasadmin";
                String passwd = "rasadmin";

                DBag resultBag = null;
                RasMArrayDouble result = null;
                Transaction myTa = null;
                Database myDb = null;
                OQLQuery myQu = null;

                RasImplementation myApp =
                                new RasImplementation("http://" + server + ":" + port);
                myApp.setUserIdentification(user, passwd);
                myDb = myApp.newDatabase();
                myDb.open(base, Database.OPEN_READ_WRITE);

                //DFZ 5/23/16: attempt to create the collection
                try {
                        myTa = myApp.newTransaction();
                        myTa.begin();
                        myQu = myApp.newOQLQuery();
                        myQu.create("create collection " + coll +" DoubleSet3");
                        myQu.execute();
                        myTa.commit();

                        myTa = myApp.newTransaction();
                        myTa.begin();
                        myQu = myApp.newOQLQuery();
                        myQu.create("drop collection " + coll);
                        myQu.execute();
                        myTa.commit();
                } catch (Exception e) {
                        System.out.println(e.getMessage());
                        System.out.println("Please ignore the above error, it's benign.\n");
                        res = 1;
                }

                myDb.close();
                return res;
        }

        /*
         * DFZ 5/23/16: added
         */
        public static void store (String coll, double[][][][] rawData) throws ODMGException, RasResultIsNoIntervalException {
                String server = "localhost";
                String base = "RASBASE";
                String port = "7001";
                String user = "rasadmin";
                String passwd = "rasadmin";

//              DBag resultBag = null;
//              RasMArrayDouble result = null;
                Transaction myTa = null;
                Database myDb = null;
                OQLQuery myQu = null;

                System.out.println("\nOpening database ...");
                RasImplementation myApp =
                                new RasImplementation("http://" + server + ":" + port);
                myApp.setUserIdentification(user, passwd);
                myDb = myApp.newDatabase();
                myDb.open(base, Database.OPEN_READ_WRITE);

                //purge the old data, if needed
                try {
                        myTa = myApp.newTransaction();
                        myTa.begin();
                        myQu = myApp.newOQLQuery();
                        myQu.create("drop collection " + coll);
                        myQu.execute();
                        myTa.commit();
                } catch (Exception e) {
                        System.out.println(e.getMessage());
                        System.out.println("Please ignore the above error, it's benign.");
                        System.out.println("No need to drop " + coll +"; it doesn't exist.\n");
                }

                System.out.println("\nStarting transaction ...");
                myTa = myApp.newTransaction();
                myTa.begin();

                //create a new collection
                myQu = myApp.newOQLQuery();
                myQu.create("create collection " + coll +" DoubleSet3");
                myQu.execute();

                //save MDDs to Rasdaman
                double[] myArray = new double[145*174*145];
                RasMArrayDouble myMDD = new RasMArrayDouble(
                                new RasMInterval("[1:145,1:174,1:145]"));
                int t;
                for (t = 0; t < 288; t++) { //DFZ TODO: 9 lifted to 288
                        System.out.println("Saving MDD #" + t);
                        for (int x = 0; x < 145; x++) { //start from 66 for non zero
                                for (int y = 0; y < 174; y++) { //start from 55 for non zero
                                        for (int z = 0; z < 145; z++){ //start from 4 for non zero
                                                myArray[x*145*174 + y*145 + z] = rawData[x][y][z][t]; //start from 58501
                                        }
                                }
                        }

                        myMDD.setArray(myArray);
                        myMDD.setObjectTypeName("DoubleCube"); //is the argument arbitrary? no

                        myQu = myApp.newOQLQuery();
                        myQu.create("insert into " + coll + " values $1");
                        myQu.bind(myMDD);
                        myQu.execute();
                }
                System.out.println("\n" + t +" MDDs saved to Rasdaman.");

                System.out.println("Committing transaction ...");
                myTa.commit();
                System.out.println("Closing database ...");
                myDb.close();
        }

        /*
         * DFZ 5/23/16: added
         */
        public static double[] query()
                        throws RasResultIsNoIntervalException, IOException {
                return query("mri");
        }

        /*
         * DFZ 5/23/16: add an argument to query to be used in multiple collections
         */
        public static double[] query(String coll)
                        throws IOException, RasResultIsNoIntervalException {
                /*
                 * DFZ: start dealing with Rasdaman
                 */
                final int VOL_SIZE = 145*174*145;
                double[] valArray = new double[VOL_SIZE];
                double[] res = new double[VOL_SIZE*288];

                String server = "localhost";
                String base = "RASBASE";
                String port = "7001";
                String user = "rasadmin";
                String passwd = "rasadmin";

                DBag resultBag = null;
                RasMArrayDouble result = null;
                Transaction myTa = null;
                Database myDb = null;
                OQLQuery myQu = null;

                try {
                        RasImplementation myApp =
                                        new RasImplementation("http://" + server + ":" + port);
                        myApp.setUserIdentification(user, passwd);

                        myDb = myApp.newDatabase();

                        System.out.println("\nOpening database ...");
                        myDb.open(base, Database.OPEN_READ_ONLY);
                        myTa = myApp.newTransaction();
                        myTa.begin();
                        myQu = myApp.newOQLQuery();
                        myQu.create("select c from " + coll + " as c");
                        System.out.println("Before query");
                        resultBag = (DBag) myQu.execute();
                        System.out.println("resultBag completed");

                        if (resultBag != null) {
                                int volIndex = 0;
                                Iterator iter = resultBag.iterator();
                                while (iter.hasNext()) {
                                        result = (RasMArrayDouble) iter.next();
                                        valArray = result.getDoubleArray();
                                        System.arraycopy(valArray, 0, res, volIndex*VOL_SIZE, VOL_SIZE);
                                        long sz = result.getArraySize();
                                        System.out.println("Retrieved Volume #" + volIndex++ + " form Rasdaman/" + coll);
                                        //DFZ: print the first 100 values
//                                      int cnt = 0;
//                                      for (int i = 0; i < sz/8 && cnt < 16; ++i) {
//                                              if (valArray[i] > 0.0005) {
//                                                      cnt++;
//                                                      System.out.print(i + ": " + valArray[i]);
//                                                      if (0 == cnt%4) {
//                                                              System.out.println();
//                                                      }
//                                                      else {
//                                                              System.out.print(", ");
//                                                      }
//                                              }
//                                      }
                                }
                                System.out.println("\nAll data loaded successfully.");
                        }
                        System.out.println("Committing transaction ...");
                        myTa.commit();
                        System.out.println("Closing database ...");
                        myDb.close();

                } catch (org.odmg.ODMGException e) {
                        System.out.println("An exception has occurred: " + e.getMessage());
                        System.out.println("Try to abort the transaction ...");
                        if (myTa != null)
                                myTa.abort();

                        try {
                                System.out.println("Try to close the database ...");
                                if (myDb != null)
                                        myDb.close();
                        } catch (org.odmg.ODMGException exp) {
                                System.err.println("Could not close the database: "
                                                + exp.getMessage());
                        }
                }
                System.out.println("Done.\n");
                return res;
        }

}
